import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'nemonic_sdk_platform_interface.dart';

/// An implementation of [NemonicSdkPlatform] that uses method channels.
class MethodChannelNemonicSdk extends NemonicSdkPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('nemonic_sdk');

  @override
  Future<String?> getPlatformVersion() async {
    final version = await methodChannel.invokeMethod<String>('getPlatformVersion');
    return version;
  }
}
