import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'nemonic_sdk_method_channel.dart';

abstract class NemonicSdkPlatform extends PlatformInterface {
  /// Constructs a NemonicSdkPlatform.
  NemonicSdkPlatform() : super(token: _token);

  static final Object _token = Object();

  static NemonicSdkPlatform _instance = MethodChannelNemonicSdk();

  /// The default instance of [NemonicSdkPlatform] to use.
  ///
  /// Defaults to [MethodChannelNemonicSdk].
  static NemonicSdkPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [NemonicSdkPlatform] when
  /// they register themselves.
  static set instance(NemonicSdkPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
