import 'package:flutter_test/flutter_test.dart';
import 'package:nemonic_sdk/nemonic_sdk.dart';
import 'package:nemonic_sdk/nemonic_sdk_platform_interface.dart';
import 'package:nemonic_sdk/nemonic_sdk_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockNemonicSdkPlatform
    with MockPlatformInterfaceMixin
    implements NemonicSdkPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');
}

void main() {
  final NemonicSdkPlatform initialPlatform = NemonicSdkPlatform.instance;

  test('$MethodChannelNemonicSdk is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelNemonicSdk>());
  });

  test('getPlatformVersion', () async {
    NemonicSdk nemonicSdkPlugin = NemonicSdk();
    MockNemonicSdkPlatform fakePlatform = MockNemonicSdkPlatform();
    NemonicSdkPlatform.instance = fakePlatform;

    expect(await nemonicSdkPlugin.getPlatformVersion(), '42');
  });
}
